Debian Bug report logs - #669156
Illegal bang-pattern (use -XBangPatterns)

version graph

Package: src:haskell-language-javascript; Maintainer for src:haskell-language-javascript is Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>;

Reported by: Joachim Breitner <nomeata@debian.org>

Date: Tue, 17 Apr 2012 20:03:03 UTC

Severity: serious

Tags: fixed-upstream

Fixed in version 0.5.4-1

Done: Joachim Breitner <nomeata@debian.org>

Bug is archived. No further changes may be made.

Forwarded to https://github.com/alanz/language-javascript/issues/10

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#669156; Package alex. (Tue, 17 Apr 2012 20:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
New Bug report received and forwarded. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Tue, 17 Apr 2012 20:03:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Illegal bang-pattern (use -XBangPatterns)
Date: Tue, 17 Apr 2012 21:59:23 +0200
Package: alex
Version: 3.0.1-1
Severity: serious

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Hi,

this is just a reminder that alex might have to be fixed to prevent
these build errors of haskell-language-javascript on unregistered arches
(mips, s390, s390x, sparc):
https://buildd.debian.org/status/package.php?p=haskell-language-javascript

Greetings,
Joachim


- -- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (101, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 3.2.0-2-amd64 (SMP w/2 CPU cores)
Locale: LANG=de_DE.utf8, LC_CTYPE=de_DE.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages alex depends on:
ii  libc6     2.13-27
ii  libffi5   3.0.10-3
ii  libgmp10  2:5.0.4+dfsg-1

alex recommends no packages.

alex suggests no packages.

- -- no debconf information

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAk+Ny5sACgkQ9ijrk0dDIGzjwQCguIhEI+dgmOJ1Lly7USuAvNtO
rE4AniPs1TC2wC3+Oh/g3cBvv0Fs9d3I
=7eAe
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#669156; Package alex. (Sat, 21 Apr 2012 04:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Erik de Castro Lopo <mle+hs@mega-nerd.com>:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sat, 21 Apr 2012 04:06:03 GMT) Full text and rfc822 format available.

Message #10 received at 669156@bugs.debian.org (full text, mbox):

From: Erik de Castro Lopo <mle+hs@mega-nerd.com>
To: 669156@bugs.debian.org
Subject: Re: Illegal bang-pattern (use -XBangPatterns)
Date: Sat, 21 Apr 2012 13:56:58 +1000
Joachim Breitner wrote:

> this is just a reminder that alex might have to be fixed to prevent
> these build errors of haskell-language-javascript on unregistered arches
> (mips, s390, s390x, sparc):
> https://buildd.debian.org/status/package.php?p=haskell-language-javascript

This is not a problem with unregistered arches so much as big-endian
arches (ie it also affects powerpc which is registered I believe).

Furthermore, from memorym, the alex generated haskell files have bang
patterns on big endian arches but not on little endian.

Still working on this.

Erik
-- 
----------------------------------------------------------------------
Erik de Castro Lopo
http://www.mega-nerd.com/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#669156; Package alex. (Sun, 22 Apr 2012 04:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to debian-haskell@lists.debian.org:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 22 Apr 2012 04:09:03 GMT) Full text and rfc822 format available.

Message #15 received at 669156@bugs.debian.org (full text, mbox):

From: Erik de Castro Lopo <mle+hs@mega-nerd.com>
To: 669156@bugs.debian.org
Cc: debian-haskell@lists.debian.org
Subject: Re: Illegal bang-pattern (use -XBangPatterns)
Date: Sun, 22 Apr 2012 14:04:20 +1000
Hi all,

I have managed to debug this issue.

The problem is that upstream ships a file

    src/Language/JavaScript/Parser/Lexer.hs

that was generated by the alex lexer generator. However, compiling
alex generated files on big endian systems (like powerpc) requires
the BangPatterns LANGUAGE pragma.

The reason we don't see this elsewhere is that other projects ship
the alex source and Debian's alex is patched to fix this. Unfortunately
I was never able to push that patch upstream [0], but maybe its time
to try again with a slightly different version of the patch.

That brings us to the language-javascript problem. Firstly, we should
really ask upstream to ship the Lexer.x file from which the Lexer.hs
file is generated. However the reason they reason they ship the haskell
source rather than the lexer source is so that its possible to install
language-javascript using "cabal install". Cabal has one rather severe
limitation, it cannot reliably install build tools like alex. Firstly
there is no way to specify a dependency on a build tool, secondly
cabal install will install it by default in $HOME/.cabal/bin/ and if
that is not on the user's PATH, language-javascript will not compile.

Cheers,
Erik

[0] http://trac.haskell.org/haskell-platform/ticket/171
-- 
----------------------------------------------------------------------
Erik de Castro Lopo
http://www.mega-nerd.com/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#669156; Package alex. (Sun, 22 Apr 2012 07:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 22 Apr 2012 07:21:04 GMT) Full text and rfc822 format available.

Message #20 received at 669156@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: debian-haskell@lists.debian.org, 669156@bugs.debian.org
Subject: Re: Bug#669156: Illegal bang-pattern (use -XBangPatterns)
Date: Sun, 22 Apr 2012 03:17:38 -0400
[Message part 1 (text/plain, inline)]
Erik de Castro Lopo wrote:
> That brings us to the language-javascript problem. Firstly, we should
> really ask upstream to ship the Lexer.x file from which the Lexer.hs
> file is generated. However the reason they reason they ship the haskell
> source rather than the lexer source is so that its possible to install
> language-javascript using "cabal install". Cabal has one rather severe

They could at least ship both and not build the .hs by default.

> limitation, it cannot reliably install build tools like alex. Firstly
> there is no way to specify a dependency on a build tool, secondly
> cabal install will install it by default in $HOME/.cabal/bin/ and if
> that is not on the user's PATH, language-javascript will not compile.

FWIW, there are ways to use Distribution.Simple to get at the binDir,
which could, at least in theory, be used to find and run programs
installed to it.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>:
Bug#669156; Package alex. (Sun, 22 Apr 2012 08:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>. (Sun, 22 Apr 2012 08:57:11 GMT) Full text and rfc822 format available.

Message #25 received at 669156@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: pkg-haskell-maintainers@lists.alioth.debian.org
Cc: 669156@bugs.debian.org
Subject: Re: Bug#669156: Illegal bang-pattern (use -XBangPatterns)
Date: Sun, 22 Apr 2012 10:54:23 +0200
[Message part 1 (text/plain, inline)]
Hi,

Am Sonntag, den 22.04.2012, 03:17 -0400 schrieb Joey Hess:
> Erik de Castro Lopo wrote:
> > That brings us to the language-javascript problem. Firstly, we should
> > really ask upstream to ship the Lexer.x file from which the Lexer.hs
> > file is generated. However the reason they reason they ship the haskell
> > source rather than the lexer source is so that its possible to install
> > language-javascript using "cabal install". Cabal has one rather severe
> 
> They could at least ship both and not build the .hs by default.

indeed they need to if Debian should be able to distribute the package.

What others do in that situation, including alex itself, is to ship the
generated files in dist/ so that for users using cabal-install, no alex
is needed. I even recall that "Setup sdist" actually does that, or can
somehow be made to do so. This could be suggested to upstream.


Greetings,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Bug reassigned from package 'alex' to 'src:haskell-language-javascript'. Request was from Joachim Breitner <nomeata@debian.org> to control@bugs.debian.org. (Sun, 22 Apr 2012 08:57:19 GMT) Full text and rfc822 format available.

No longer marked as found in versions alex/3.0.1-1. Request was from Joachim Breitner <nomeata@debian.org> to control@bugs.debian.org. (Sun, 22 Apr 2012 08:57:20 GMT) Full text and rfc822 format available.

Set Bug forwarded-to-address to 'https://github.com/alanz/language-javascript/issues/10'. Request was from Joachim Breitner <nomeata@debian.org> to control@bugs.debian.org. (Sun, 22 Apr 2012 09:16:35 GMT) Full text and rfc822 format available.

Added tag(s) fixed-upstream. Request was from bts-link-upstream@lists.alioth.debian.org to control@bugs.debian.org. (Thu, 26 Apr 2012 16:42:24 GMT) Full text and rfc822 format available.

Reply sent to Joachim Breitner <nomeata@debian.org>:
You have taken responsibility. (Sat, 19 May 2012 17:39:09 GMT) Full text and rfc822 format available.

Notification sent to Joachim Breitner <nomeata@debian.org>:
Bug acknowledged by developer. (Sat, 19 May 2012 17:39:09 GMT) Full text and rfc822 format available.

Message #38 received at 669156-done@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: 669156-done@bugs.debian.org
Subject: Was actually fixed with last upload
Date: Sat, 19 May 2012 19:36:16 +0200
[Message part 1 (text/plain, inline)]
Version: 0.5.4-1
-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 13 Jul 2012 07:42:09 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 16:41:06 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.